# pos     : exp of inner products for positive examples
# neg     : exp of inner products for negative examples
# N       : number of negative examples
# t       : temperature scaling
# tau_plus: class probability
# beta    : concentration parameter

#Clipping negatives trick before computing reweighting 
reweight = 2*neg / max( neg.max().abs(), neg.min().abs() )
reweight = (beta*reweight) / reweight.mean()
Neg = max((-N*tau_plus*pos + reweight*neg).sum() / (1-tau_plus), e**(-1/t))
hard_loss = -log( pos.sum() / (pos.sum() + Neg))